#include <stdio.h>
#include <string.h>
#include <stdlib.h>

// == Vul deze functies in ==

/* determine the length of a string. Strings end in the character '\0'
 * Hint: Remember that you can access the next character after a 
 * character pointer by incrementing the pointer by one.
 */
size_t myStrlen(const char *s) {
    return 0;
}

/* Copy an entire string from source to dest
 */
char *myStrcpy(char *dest, const char *source) {
    return dest;
}

/* Accept a string and parse it as an integer. If the string does not parse as
 * a valid integer, return 0. If there's additonal text after a number, return
 * the parsed number and ignore everything after it.
 */
int myAtoi(const char *str) {
    return 0;
}

/* Compare two strings lexicographically: If  s1 and s2 are equal, return 0.
 * If s1 would be found earlier in the dictionary than s2, return -1
 * If s2 would be found earlier in the dictionary than s1, return 1
 */
int myStrcmp(const char *s1, const char *s2) {
    return 0;
}

// == This code is used to unit-test your functions. ==

void assert(int condition, const char *message) {
    if(!condition) {
        printf("Assertion failed: %s\n", message);
    }
}

int main() {
    char buf[255] = {0};

    assert(myStrlen("") == 0, "Length of empty string should be 0");
    assert(myStrlen("abcd") == 4, "Length of string abcd should be 4");
    assert(myStrlen(buf) == 0, "Length of empty buffer should be 0");

    myStrcpy(buf, "abc");

    assert(buf[0] == 'a' && buf[1] == 'b' && buf[2] == 'c', "Buffer should contain abc");
    assert(buf[3] == '\0', "Buffer should be terminated with '\\0'");
    assert(myStrlen(buf) == 3, "Buffer strlen should be 3");

    myStrcpy(buf, "");

    assert(buf[0] == '\0', "Buffer should contain nothing");
    assert(myStrlen(buf) == 0, "Buffer length should be 0");

    assert(myAtoi("abc") == 0, "atoi of \"abc\" should be 0");
    assert(myAtoi("123") == 123, "atoi of \"123\" should be 123");
    assert(myAtoi("") == 0, "atoi of empty string should be 0");
    assert(myAtoi("-1") == -1, "atoi of \"-1\" should be -1");

    assert(myStrcmp("axvchsaiduvnsdif", "bsadvsivnsaidnv") == -1, "incorrect strcmp: axvchsaiduvnsdif < bsadvsivnsaidnv");
    assert(myStrcmp("csadfjisdgo", "bfsadoijfoijbcxlzj") == 1, "incorrect strcmp: csadfjisdgo > bfsadoijfoijbcxlzj");
    assert(myStrcmp("bababa", "bababa") == 0, "incorrect strcmp: bababa == bababa");
    assert(myStrcmp("", "abc") == -1, "incorrect strcmp: the empty string should be before all other words");
    assert(myStrcmp("", "") == 0, "incorrect strcmp: the empty string should equal the empty string");
    assert(myStrcmp("abcda", "abcdb") == -1, "incorrect strcmp: abcda < abcdb");

    return 0;
}
